#include "MSP430x16x.h"
#include "string.h"
#include"stdlib.h"
#include"flash.h"
/*******************************************************************************/         
/*                        дӳ                                           */
/*******************************************************************************/
/**----------------------------------ļϢ------------------------------
    **       : flash.c
    **       : ĺ 
    ** ޸: 20100721
    **         : MSP430оƬFLAHSEEPROM,βд
    **  
    **-----------------------------------------------------------------------------------
************************************************************************************/



/************************************************************************************
** : flashWrite
** : MSP430flashд
**
** 䡡  :   td:дַ, sd:Դָ, size:дֽ
** 䡡  :   
**   ֵ:   Ҫ͸ݿָ롣
** ȫֱ: 
** ģ: 
**   : ĺ
** ա  : 20100712
************************************************************************************/
void flashWrite(unsigned char * td, unsigned char *sd, unsigned char size)
{
    typedef void(*funp)(unsigned char*,unsigned char *, unsigned char);                      //庯ָ
    funp FLASHBLK;    
    char ramcode[100];								//ramڳַָ    
    _DINT();	
    //ramcode=(char *)malloc(sizeof(char)*100);   //Ϊڴӳ̷ռ(ȽheapֵΪ180)
    FLASHBLK = flashWriteBlock;                        //ָ븳ֵ
    memcpy(ramcode,(char *)FLASHBLK,100);       //дӳ̷ramѷռ
    FLASHBLK=*(funp)ramcode;                    //ָָramеĿдӳ
    flashErase(td);                                //β
    (FLASHBLK)(td,sd, size);                               //д(õramеĿдӳ)
    //free(ramcode);                              //ͷſռ
    _EINT();						//ж
}
  
  
  void flashWriteBlock(unsigned char * td,unsigned char *sd, unsigned char size)
  {
    int i;
	
    while((FCTL3&BUSY)!=0x00);                  //busyλ
    FCTL2=FWKEY+FSSEL_1+20;                    //flashģʱԴΪMCLK Ƶ2
    FCTL3=FWKEY;                                //
    FCTL1=FWKEY+BLKWRT+WRT;                     //д
    for(i=0;i<size;i++)                           //д64ֽ
    {        
        *td++=*sd++;                    //д
        while((FCTL3&WAIT)==0);                 //waitλ Ƿд
    }
    FCTL1=FWKEY;                                //BLKWRT WRTλλ
    while((FCTL3&BUSY)!=0x00);                  //BUSYλ
    FCTL3=FWKEY+LOCK;                           //
	
}
/*******************************************************************************/         
/*                        βӳ                                         */
/*******************************************************************************/
void flashErase(unsigned char *td)
{
    FCTL2=FWKEY+FSSEL_1+10;                    //flashģʱԴλMCLK Ƶ2
    FCTL3=FWKEY;                                //
    FCTL1=FWKEY+ERASE;                          //β
    *td=0;                               //вĶпд,
    FCTL3=FWKEY+LOCK;                           //  
}

//ܣFLASH BYTEд
//ʱ:257KHZ~476KHZ
void flashWriteByte(unsigned char * pdata, unsigned char data)
{
	//WDTCTL = WDTPW + WDTHOLD;	//رտŹ
	_DINT();					//رж
	FCTL2 = FWKEY+FSSEL1+12;	//3686400/300K=12
	FCTL3 = FWKEY;				//LOCK=0;
	FCTL1=FWKEY+WRT;			//WRT=1;
	*pdata = data;
	FCTL3 = FWKEY+LOCK;			//
	//ͨŹ
	_EINT();						//ж
}

void flashWriteWord(unsigned short * pdata, unsigned short data)
{
	//WDTCTL = WDTPW + WDTHOLD;	//رտŹ
	_DINT();					//رж
	FCTL2 = FWKEY+FSSEL1+12;
	FCTL3 = FWKEY;				//LOCK=0;
	FCTL1=FWKEY+WRT;			//WRT=1;
	*pdata = data;
	FCTL3 = FWKEY+LOCK;			//
	//ͨŹ
	_EINT();						//ж
}


